<?php
/*

 $Id: autoreg.php,v 1.15 2003/07/16 21:15:12 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/modules/autoreg.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Autoregistration Document
	This is the autoreg page, It uses a different header and footer. You will only
	See this page if you don't have access to any zones or click on the link within
	Maintain. Autoregistration depends on the $conf['module']->autoreg configs, currently
	there is support for multiple "AutoReg" sites, see config for examples
*/

/* Start House Keeping */
	
	require "../../modules/config.php";

	// do anything that needs to be done here
	check_session();

	// setup the user environment
	setup_user_environment($action, $zone_id);

/* End House Keeping */

/*  Make needed objects */
$autoreg = new Autoreg(0);
$info = $conf['modules']->get_info("autoreg");

// Check to make sure they have an autoreg_type
if (!$user->autoreg_type) {
	header("Location: " . $conf['web_path'] . "/modules/autoreg_portal.php");
	exit();
}



// If this site uses the ACL we need to check and make sure that
// this user is allowed to get here...


if ($blah) {
	// if false re-direct them
	if (!$autoreg->has_acl_access($user->username,$user->autoreg_type)) {
		show_template('header');
		$user->autoreg_type = false;
		$conf['ui']->show_access_denied();
		show_template('footer');
		exit();
	}

} // if acl

if ($agree) { $aup = "accepted"; } 

// if we can't find the headers
if (!$info['header'][$user->autoreg_type]) {
	$user->autoreg_type = $autoreg->get_type($conf['zone']->name);
} 


require( $conf['prefix'] . "/" . $info['header']["$user->autoreg_type"] );




 
/*!
	@function update_host
	@discussion called when we are updating an existing host
*/
if ($action == "update_host") {
        //create the objects so we can do a bunch of checking
        $host = new Host($host_id);

        //remove any non-valid chr's from the mac addie
        $mac = $conf['ui']->clean_hardware_address($mac);
	
	// Get all the ranges for this autoreg type
	$ranges = $autoreg->get_autoreg_ranges($user->autoreg_type);

        //check the HW Addie if it has changed
	if ($host->ha != $mac) {
		$host->zone->id = $autoreg->get_zone_id();

		// go through all the ranges in this autoreg
		foreach ($ranges as $range) { 
		        $host->check_hardware_address($mac,0,$range->id);
		} 

	} // end if HA has changed

        //if no error found
        if (!$conf['error']->error_state AND $user->username = $host->other_id) {

                $autoreg->update_host($host_id,$mac,$hardware_type,$user->username);

		//Get all other hosts inside "Public" autoreg sites and nuke those as well..
		foreach ($info['cross_populate'] as $key => $cross_populate) {
			if ($key != $user->autoreg_type AND $cross_populate) {
				$auto_host = $autoreg->get_host($host->ha,$key);
				$autoreg->update_host($auto_host->id,$mac,$hardware_type,$user->username,$key,"auto_add");
			} 

		} // end foreach

		$conf['ui']->display_confirmation("Host Updated", "Your Computer has been update the change will come into effect in 5 to 10 min.", $conf['web_path'] . "/modules/autoreg.php?aup=accepted&amp;autoreg_type=$user->autoreg_type");

        } //no error found

	else {
		echo "<p><font size=\"+2\"><b>The Following Error(s) Occured</b></font></p>";
		$conf['error']->show_message('ha');
		echo "<br /><br /><a href=\"". $conf['web_path'] . "/modules/autoreg.php?aup=accepted&amp;autoreg_type=" . $user->autoreg_type . "\">[Continue]</a>";
	} //end else

} // update_host

/*!
	@function delete
	@discussion deleting a autoreg host, when doing this they must be the user ($host->other_id) or an admin
*/
elseif ($action == "Delete") {
	$host = new Host($host_id); 
	$ha = $host->ha;

	if ($user->username == $host->other_id OR $user->is_admin) { 
		$host->delete();

		//Get all other hosts inside "Public" autoreg sites and nuke those as well..
		foreach ($info['cross_populate'] as $key => $cross_populate) {
			if ($key != $user->autoreg_type AND $cross_populate) {
				$auto_host = $autoreg->get_host($ha,$key);
				$auto_host->delete();
			} 

		} // end foreach
		$conf['ui']->display_confirmation("Host Deleted", "Your Computer has been deleted from our records.", $conf['web_path'] . "/modules/autoreg.php?aup=accepted&amp;autoreg_type=" . $user->autoreg_type);
	} // check perms

	else {
		$conf['ui']->show_access_denied();
	}
	
} //delete

// we are making a new entry
elseif ($action == "new_host") {
	//create the objects so we can do a bunch of checking
	$host = new Host(0);
	$autoreg = new Autoreg(0);

	//remove any non-valid chr's from the mac addie
	$mac = $conf['ui']->clean_hardware_address($mac);

	$ranges = $autoreg->find_autoreg_dynamic();
	$host->zone->id = $autoreg->get_zone_id();
	
	//check the HW Addie
	foreach ($ranges as $range) {
		$host->check_hardware_address($mac,0,$range->id);
		if ($conf['error']->error_state) { break; }
	}

	//if no error found
	if (!$conf['error']->error_state) {

		$autoreg->add_host($mac,$hardware_type,$user->username);

		// Add this host to all other "Public" sites
		foreach ($info['cross_populate'] as $key => $cross_populate) {
			// If it's not the current site and it's public let's roll
			if ($key != $user->autoreg_type AND $cross_populate) {
				$ranges = $autoreg->find_autoreg_dynamic($key);
			        $host->zone->id = $autoreg->get_zone_id($key);
			
				foreach ($ranges as $range) {
					$host->check_hardware_address($mac,0,$range->id);
					if ($conf['error']->error_state) { break; }
				} // End Foreach

				if (!$conf['error']->error_state) {
					$autoreg->add_host($mac,$hardware_type,$user->username,$key,"auto_add");
				}

			}

		} // End foreach


		$conf['ui']->display_confirmation("Host Added", "Your Computer has been added, it should be live in 5 to 10 min.", $conf['web_path'] . "/modules/autoreg.php?aup=accepted&amp;autoreg_type=$user->autoreg_type");

	} //no error found

		else {
		echo "<p><font size=\"+2\"><b>The Following Error(s) Occured</b></font></p>";
		$conf['error']->show_message('ha');
		echo "<br /><br /><a href=\"". $conf['web_path'] . "/modules/autoreg.php?aup=accepted\">[Continue]</a>";
	} //end else

} //new_host

/*!
	@function create_host
	@discussion Admin Create, actually create the host
*/
elseif ($action == "create_host" AND $user->has_access($conf['zone']->id)) {

        //create the objects so we can do a bunch of checking
        $host = new Host(0);
        $autoreg = new Autoreg(0);

        //remove any non-valid chr's from the mac addie
        $mac = $conf['ui']->clean_hardware_address($mac);

        $ranges = $autoreg->find_autoreg_dynamic();
        $host->zone->id = $autoreg->get_zone_id();

	//check the username against ldap
	$error = $user->check_auth_name($username);
	if ($error) {
		$conf['error']->add_error('username',$error);
	}

        //check the HW Addie
        foreach ($ranges as $range) {
                $host->check_hardware_address($mac,0,$range->id);
                if ($conf['error']->error_state) { break; }
        }

        //if no error found
        if (!$conf['error']->error_state) {

		if ($expire) { $expire = time() + (86400 * $expire); }

                $host_id = $autoreg->add_host($mac,$type,$username,$autoreg_type,0,"Administrative Add by $user->username");
		$host = new Host($host_id); 
		$host->update_expire($expire);
		$conf['ui']->display_confirmation("Host Added", "$username's Computer has been added.", $conf['web_path'] . "/index.php");
	}

	else {
		$action = "show_create_host";
	}

} // create_host

/********************
  DISPLAY IF BLOCK
********************/

/*!
	@function show_create_host
	@discussion Shows the Admin Host create.
*/
if ($action == "show_create_host" AND $user->has_access($conf['zone']->id)) {

	require ($conf['prefix'] . "/templates/show_autoreg_create_host.inc");

} // show_create_host

/****************************************************************
Ok now they are here let's go ahead and make a new autoreg object
****************************************************************/


$autoreg = new Autoreg($user->username);
$blank_count = $info['hostcount']["$user->autoreg_type"] - count($autoreg->hosts);
if (($autoreg->hosts or $aup == "accepted") AND !$action AND !$autoreg->disabled) {

	show_template('autoreg_fluf_top');

	//we need to see if they are doing the autoreg coolness, if so let's populate their mac
	$autoreg_host = $autoreg->is_pub_host();

	//if the autoreg host was found show the pre-populated
	//information for them to add... 
	if ($autoreg_host AND $blank_count > "0") {
		require ($conf['prefix'] . "/templates/show_autoreg_host.inc");
	} 

	//clean up the mess
	unset($autoreg_host);
	
	if ($autoreg->hosts) { 
		foreach ($autoreg->hosts as $h) {
			$host = new Host($h->id);
			require ($conf['prefix'] . "/templates/show_autoreg_host.inc");
		} //end foreach set hosts
	} // if we found hosts..	

	unset($host);

	//if they have any empty spaces
	if ($blank_count > "0") {
		while ($blank_count) {
		require ($conf['prefix'] . "/templates/show_autoreg_host.inc");	
		$blank_count = $blank_count - 1;
		} //end while
	} //end if for blank_count

	// look for hosts that are in a different autoreg site
	$hosts = $autoreg->get_other_hosts($user->autoreg_type);
	if (count($hosts)) { 
		foreach($hosts as $host) {
			require ($conf['prefix'] . "/templates/show_autoreg_host.inc");
		}
//		$autoreg->show_other_hosts($hosts);
		
	} // if hosts

	show_template('autoreg_fluf_bottom');
	
} 
elseif ($autoreg->disabled) { 
	show_template ('autoreg_disabled'); 
}

//if they don't have any hosts then we need to show them the AUP
elseif ($aup != "accepted") {
	require ($conf['prefix'] . "/templates/show_autoreg_aup.inc");
}

require ( $conf['prefix'] . "/" . $info['footer'][$user->autoreg_type] );



?>


