<?php
/*

 $Id: pointer.php,v 1.1 2003/07/21 05:02:04 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/pointer.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Forward and Reverse Pointer document
	Document that hold actions relating to forward and reverse pointers

*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
	check_session();

	setup_user_environment($action, $zone_id);
/* End House Keeping */

// Only Admins for now...
if (!$user->is_admin) {
	header("Location: " . $conf['web_path'] . "/index.php");
	exit();
} 

// Create needed objects
$pointer = new Pointer($pointer_id);

show_template('header');

echo "<p class=\"header2\">Managing Forward/Reverse Pointers</p>";

/*********************
     WORK IF BLOCK
*********************/


/*!
	@function create_forward_pointer
	@discussion creates a forward pointer
		    www.domain.com --> IP ADDR
*/
if ($action == 'create_forward_pointer') {

	// Create the objects we are going to need
	$ip = new IP(0);

	// First make sure we have valid fields
	if (!$ip->is_dotted_quad($ip_addr)) {
		$conf['error']->add_error('ip_addr', "Invalid IP Address Entered");
	}

	if (!preg_match("/^[\w\-\d]+\.[\w\-\d]+/", $hostname)) {
		$conf['error']->add_error('hostname', "Invalid Hostname Entered");
	}

	if (!is_numeric($ttl)) {
		$conf['error']->add_error('ttl',"Time to live must be numeric");
	}

	//For forward pointers (domain --> IP) we just check to make sure domain is under their control
	$data = split_hostname($hostname);
	$sql = "SELECT id FROM domain WHERE name='$data->domain'";
	$db_results = mysql_query($sql, $conf['dbh']);
	
	$results = mysql_fetch_object($db_results);
	if (!$conf['zone']->has_domain_access($results->id)) {
		$conf['error']->add_error('hostname',$conf['zone']->name . " does not have access to " . $data->domain);
	} 

	// Make sure we don't have a A Record or a CNAME with this hostname
	// this functions sets the errors in it's self	
	$pointer->check_hostname($data->name,$data->domain,$type);

	if (!$conf['error']->error_state) {

		$pointer_id = $pointer->create_pointer($hostname,$ip->ip2int($ip_addr),$ttl,$type);
		$conf['ui']->display_confirmation("Pointer Created", "$hostname has been created as a forward pointer to $ip_addr", $conf['web_path'] . "/pointer.php?action=show_pointer&amp;pointer_id=$pointer_id");

	} // no errors!

	else {
		$action = 'show_create_pointer';
		$type = 'forward';
	}


} // create_forward_pointer

/*!
	@function create_reverse_pointer
	@discussion creates a reverse pointer
		    IP ADDR --> www.domain.com
*/
elseif ($action == 'create_reverse_pointer') {


} // create_reverse_pointer

/*!
	@function delete_pointer
	@discussion delets a forward/reverse pointer
*/
elseif ($action == 'delete_pointer') {



} // delete_pointer


/************************
   START DISPLAY BLOCK
************************/

/*!
	@function show_pointers
	@discussion shows all pointers in specified zone
*/
if ($action == 'show_pointers') { 

	

} // show_pointers

/*!
	@function show_pointer
	@discussion shows a single pointer
*/
elseif ($action == 'show_pointer') { 

	require ($conf['prefix'] . "/templates/show_pointer.inc");

} // show_pointer

/*!
	@function show_create_pointer
	@discussion show form to create a pointer in zone
*/
elseif ($action == 'show_create_pointer') {

	require($conf['prefix'] . "/templates/show_create_pointer.inc");

} // show_create_pointer

/*!
	@function show_delete_pointer
	@discussion show a confirmation, that you really want
		    to delete this pointer
*/
elseif ($action == 'show_delete_pointer') {


} // show_delete_pointer

show_template('footer');

?>
