<?
/* ------------------- CVS INFO ---------------------- 
 *	
 *	$Source: /data/cvsroot/libglue/session.php,v $
 *	last modified by $Author: hopson $ at $Date: 2003/06/28 21:57:18 $ 
 *
 * Libglue, a free php library for handling authentication 
 *   and session management. 
 *
 * Written and distributed by Oregon State University.
 *   http://oss.oregonstate.edu/libglue
 *
 * --------------------------------------------------- 
 */

/* ------------------- This File ---------------------- 
 * 
 * session.php: library for storing session data in a mysql database
 *
 * depends: config.php (for parameters)
 *
 * functions:
 *		check_session(), logout([sessid]), 
 * Functions used for session_set_save_handler():
 *		sess_open(), sess_close(),
 *		sess_read(key), sess_write(key,data),
 *		sess_destroy(key), sess_gc(maxlife),
 *
 * Make sure to set session.session_handler_type to 'users' in php.ini
 * Don't try to store more session data than the database field holds
 *   or weird things may happen.
 *
 * ------------------- This File ---------------------- 
 */


function check_sess_db($dbtype = "id")
{
    $golden = 0;
    switch($dbtype)
    {
        case "id":
            $dbh = libglue_param(libglue_param('sess_id_hname'));
            if(is_resource($dbh)) $golden = 1;
            else
            {
        	$dbh = setup_sess_db(libglue_param('sess_id_hname'),
                                       libglue_param('sess_host'), 
				       libglue_param('sess_db'), 
				       libglue_param('sess_user'), 
				       libglue_param('sess_pass'));
                if(is_resource($dbh)) $golden = 1;
            }
            break;
        case "data":
            $data_db = libglue_param('sess_data_db');
            if(empty($data_db ))
            {
                $dbh = check_sess_db();
                $golden = 1;
                break;
            }
	    $dbh = libglue_param(libglue_param('sess_id_dname'));
            if(is_resource($dbh)) $golden = 1;
            else
            {
                $dbh = setup_sess_db(libglue_param('sess_id_dname'),
                                       libglue_param('sess_data_host'), 
				       $data_db,
				       libglue_param('sess_data_user'), 
				       libglue_param('sess_data_pass'));
                if(is_resource($dbh))
                {
                    $golden = 1;
                }
            }
            break;
        default:
            $golden = 0;
    }
    if($golden == 1) return $dbh;
    else die ("Could not connect to $dbtype database for session management");
}

//
// Really we are just checking the session here -- we want to see if

//  if the user has a valid session, if they do then we'll let them do
//  what they need to do.
//
//  vollmerk -- added $noredirect that you can pass to prevent it from 
//		redirecting if you don't have a session, usefull if you
// 		want to show them extra stuff if they've logged in, but
//		still show them _something_ if they aren't logged in



function check_session($noredirect=0) 
{
	$name = libglue_param('sess_name');
        $domain = libglue_param('sess_domain');
        
        $id_dbh = check_sess_db();
        $data_dbh = check_sess_db("data");
        $same_data = ($data_dbh === $id_dbh)?1:0;

	$sesstable = libglue_param('sess_table');
	$sessidcol = libglue_param('sess_idcol');
	$sessexpirecol = libglue_param('sess_expirecol');

	if($name) session_name($name);
        if($domain) session_set_cookie_params(0,"",$domain);
	session_start();
	$id = strip_tags($_COOKIE[$name]);

	$sql = "SELECT * FROM $sesstable WHERE $sessidcol='$id'";

	$db_result = mysql_query($sql, $id_dbh);
	$session = mysql_fetch_array($db_result);
	if ( $session && (time() < $session[$sessexpirecol]) ) 
	{
            // Now we want to check the local data table, and 
            //   insert the id if we need to
            if(!$same_data)
            {
                $sess_data_table = libglue_param('sess_data_table');
                $sess_data_idcol = libglue_param('sess_data_idcol');
                $sql = "SELECT * FROM $sess_data_table WHERE $sess_data_idcol = '$id'";
                $result = mysql_query($sql, $data_dbh);
                if(mysql_num_rows($result) != 1)
                {
                    $sql = "INSERT INTO $sess_data_table ($sess_data_idcol) VALUES ('$id')";
                    $db_result = mysql_query($sql, $data_dbh);
                    if(!$db_result) die("Could not update local session info");
                }
            }
            return true;
	}

	// No session in db
	//And redirect to login page
	else
	{
		if (!$noredirect) { logout($id); }
		return false;
	}
}


// This will start the session tools, then destroy anything in the database then
//   clear all of the session information
function logout ($id=0) 
{
    if($id == 0)
    // if an id is not passed in, figure it out
    {
        $name = libglue_param('sess_name');
        $domain = libglue_param('sess_domain');
        if($name) session_name($name);
        if($domain) session_set_cookie_params(0,"",$domain);
        session_start();
        $id = strip_tags($_COOKIE[$name]);
    }
    $login_page = libglue_param('login_page');
    // should clear both the database information as well as the
    //   current session info
/*    sess_destroy($id);*/
    session_destroy();
    header("Location: $login_page");
    die();
    return true;
}

// Double checks that we have a database handle
// Args are completely ignored - we're using a database here
function sess_open($save_path, $session_name) 
{
    $id_dbh = check_sess_db();
    $data_dbh = check_sess_db("data");
    $db_name = libglue_param('sess_db');
    $host = libglue_param('sess_host');
    if ( !is_resource($id_dbh) ) 
    {
        echo "<!-- Unable to connect to \"". $host ."\" in order to " .
             "use the \"". $db_name ."\" database. Perhaps the database is not ".
             "running, or perhaps the admin needs to change a few variables in ".
             "modules/include/global_settings in order to point to the correct ".
             "database.-->\n";
        echo "<!--mysql_pconnect " .  mysql_errno() . ": " .  mysql_error() . "-->\n";
        return false;
    }
    if ( !is_resource($data_dbh) ) 
    {
        echo "<!-- Unable to connect to \"". $host ."\" in order to " .
             "use the \"". $db_name ."\" database. Perhaps the database is not ".
             "running, or perhaps the admin needs to change a few variables in ".
             "modules/include/global_settings in order to point to the correct ".
             "database.-->\n";
        echo "<!--mysql_pconnect " .  mysql_errno() . ": " .  mysql_error() . "-->\n";
        return false;
    }
    return true;
}

// Placeholder function, does nothing
function sess_close() 
{
    return true;
}

// Retrieve session identified by 'key' from the database
//   and return the data field
function sess_read($key)
{
    $id_dbh = check_sess_db();
    if(!is_resource($id_dbh)) die("Bad ID handle");

    $data_dbh = check_sess_db("data");
    if(!is_resource($data_dbh)) die("Bad Data handle");

    $same_data = ($data_dbh == $id_dbh)?1:0;
    $sess_table = libglue_param('sess_table');
    $sess_expirecol = libglue_param('sess_expirecol');
    $sess_idcol = libglue_param('sess_idcol');
    
    if($same_data)
    {
        $sess_data_col = libglue_param('sess_datacol');
        $sess_data_table = libglue_param('sess_table');
        $sql = "SELECT $sess_data_col" .
               " FROM $sess_table" .
               " WHERE  $sess_idcol = '$key' AND $sess_expirecol > " . time();
        $qid = mysql_query($sql, $id_dbh);
        if (list($value) = mysql_fetch_row($qid)) 
        {
            return $value."";
        }
        else return "";
    }

    else
    {
        /* what we do here:
           Pop over to the data database, and read our session from there.
         */
        // Fields for the separate data table
        $sess_data_table = libglue_param('sess_data_table');
        $sess_data_data = libglue_param('sess_data_data');
        $sess_data_idcol = libglue_param('sess_data_idcol');
        $sess_data_expirecol = libglue_param('sess_data_expirecol');
    
        $sql = "SELECT $sess_data_data FROM $sess_data_table" .
               " WHERE $sess_data_idcol = '$key' AND $sess_data_expirecol > " . time();
        $result = mysql_query($sql, $data_dbh);
        if (list($value) = mysql_fetch_row($result)) 
        {
            return $value."";
        }
/*        else die("Couldn't retrieve session data");*/
        else return "";
    }
    //If we get here, there's something amiss,
    //  and I won't say what, because I don't know

    die("The session database for this application is unreachable.  Please try again laster.");

}

//
// Save the session data $val to the database
//
function sess_write($key, $val)
{
    $id_dbh = check_sess_db();
    if(!is_resource($id_dbh)) die("Bad ID handle");
    $data_dbh = check_sess_db("data");
    if(!is_resource($data_dbh)) die("Bad data handle");
    $same_data = ($data_dbh == $id_dbh)?1:0;
    $sess_table = libglue_param('sess_table');
    $sess_expirecol = libglue_param('sess_expirecol');
    $sess_idcol = libglue_param('sess_idcol');
    $sess_data_length = libglue_param('sess_data_length');
    
    if($same_data)
    {
        $sess_datacol = libglue_param('sess_datacol');
        $sess_data_table = libglue_param('sess_table');
        $sess_data_idcol = libglue_param('sess_data_idcol');
        $len = libglue_param('sess_length');
        $expire = time() + $len;
        $sql = "REPLACE INTO $sess_table ($sess_idcol,$sess_expirecol,$sess_datacol)" .
               " VALUES  ('$key', '$expire', '$val')";

        $qid = mysql_query($sql, $id_dbh);
        if(!$qid) die("Couldn't retrieve session data");
    }

    else
    {
        /* what we do here:
           First, we're going to check the session database and make sure
           they're not expired.
           Then, we'll pop over to the data database, and read our session from there.
         */
        // 1 - retrieve the update interval for this session
        $sql = "SELECT $sess_data_length FROM $sess_table".
               " WHERE $sess_idcol = '$key' AND $sess_expirecol > " . time();
        $result = mysql_query($sql, $id_dbh);
        if(mysql_num_rows($result) == 1)
        {
            list($length) = mysql_fetch_row($result);
        }
        else
        {
            $length = libglue_param('sess_length');
        }
    
        // 2 - Update interval
        // Fields for the separate data table
        $sess_data_table = libglue_param('sess_data_table');
        $sess_data_data = libglue_param('sess_data_data');
        $sess_data_idcol = libglue_param('sess_data_idcol');
        $sess_data_expirecol = libglue_param('sess_data_expirecol');
        $newexpire = time() + $length;
        $sql = "REPLACE INTO $sess_table ($sess_idcol, $sess_expirecol, $sess_data_length)" .
               " VALUES ('$key', '$newexpire', '$length')";
        $result = mysql_query($sql, $id_dbh);

        // 3 - Write session data to "data" databases
	$sql = "REPLACE INTO $sess_data_table ($sess_data_idcol,$sess_data_expirecol,$sess_data_data)" . 
	       " VALUES ('$key', '$newexpire', '$val')"; 
	$qid = mysql_query($sql, $data_dbh);
	return $qid;
    }

}

//
// Remove the current session from the database.
//
function sess_destroy($key) 
{
    $id_dbh = check_sess_db();
    $data_dbh = check_sess_db("data");
    $same_data = ($data_dbh === $id_dbh)?true:false;
    $sess_table = libglue_param('sess_table');
    $sess_expirecol = libglue_param('sess_expirecol');
    $sess_idcol = libglue_param('sess_idcol');


    $sql = "DELETE FROM $sess_table WHERE $sess_idcol = '$key'";
    $result = mysql_query($sql, $id_dbh);

    if(!$same_data)
    {
        $sess_data_table = libglue_param('sess_data_table');
        $sess_data_idcol = libglue_param('sess_data_idcol');
        $sql = "DELETE FROM $sess_data_table WHERE $sess_data_idcol = '$key'";
        $qid = mysql_query($sql, $data_dbh);
    }

    return $result && $qid;
}

//
// This function is called with random frequency
//   to remove expired session data
//
function sess_gc($maxlifetime)
{
    $id_dbh = check_sess_db();
    $data_dbh = check_sess_db("data");
    $same_data = ($data_dbh === $id_dbh)?1:0;
    $sess_table = libglue_param('sess_table');
    $sess_expirecol = libglue_param('sess_expirecol');
    $sess_idcol = libglue_param('sess_idcol');


    $sql = "DELETE FROM $sess_table WHERE $sess_expirecol < " . time();
    $result = mysql_query($sql, $id_dbh);

    if(!$same_data)
    {
        $sess_data_table = libglue_param('sess_data_table');
        $sess_data_idcol = libglue_param('sess_data_idcol');
        $sess_data_expirecol = libglue_param('sess_data_expirecol');
        $sql = "DELETE FROM $sess_data_table WHERE $sess_data_expirecol < " . time();
        $qid = mysql_query($sql, $data_dbh);
    }

    return $result && $qid;

}

//
// Register all our cool session handling functions
//
session_set_save_handler(
	"sess_open",
	"sess_close",
	"sess_read",
	"sess_write",
	"sess_destroy",
	"sess_gc");
?>
