<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: child.php,v 1.10 2003/07/23 00:10:42 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/class/child.php,v $

 The child class, takes a type of object and a ID and finds any dependences.

*/

class Child {
	var $type; // the parent table of the object, for figuring out what dependence there would be
	var $id; //the ID of the object we are finding children for
	var $second_id; //for checking that requires two WHERE statements...
	var $object; //for those that require non-id fields
	var $has_children 	= false; //True or False depending on if children are there
	var $hosts 		= array();
	var $cnames 		= array();
	var $mxs 		= array();
	var $domains 		= array();
	var $zones 		= array();
	var $subnets 		= array();
	var $pointers 		= array();
	var $total 		= 0; //total child objects

	function Child ($type, $id,$second_id=0, $object=0) {

		$this->id 		= $id;
		$this->type 		= $type;
		$this->second_id	= $second_id;
		$this->object 		= $object;

		//first let's figre out what type of object we need to find children for 
		//and run the functions for them
		switch ($type === 0 ? '': $type) {
			case 'zone':
				$this->check_domains();
				$this->check_mxs();	
				$this->check_cnames();
				$this->check_hosts();
				$this->check_pointers();
				break;
			case 'domain':
				$this->check_mxs();
				$this->check_cnames();
				$this->check_hosts();
				$this->check_zones();
				$this->check_pointers();
				break;
			case 'zone_domain':
				$this->check_mxs();
				$this->checK_cnames();
				$this->check_hosts();
				break;
			case 'host':
				$this->check_hosts();
				$this->check_cnames();
				$this->check_mxs();	
				$this->check_pointers();
				break;
			case 'range':
				$this->check_range();
				break;
			case 'ip_block':
				$this->check_subnet();
				break;
		} // end switch on type

	} // Child

	function check_domains() { 
		global $conf, $user;

		//depending upon the type we need to do different selects.... Grr...
		if ($this->type == "zone") {
			$sql = "SELECT * FROM zone_domain WHERE zone='$this->id'";
			}
		
		//we've got the sql setup let's grab the objects
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($d = mysql_fetch_object($db_results)) {
		        $domain = new Domain($d->domain);
                        $this->domains[] = $domain;
			$this->has_children = true;
                        }

		//add the number of domains to the total child objects
		$this->total += count($this->domains);



	} //check_domains

	function check_mxs() { 
		global $conf, $user;

		//depending upon the type we need to do different selects.... 
		if ($this->type == "zone") {
			$sql = "SELECT * FROM zone_mx WHERE zone='$this->id'";
			}
		elseif ($this->type == "domain") {
			$sql = "SELECT * FROM zone_mx WHERE domain='$this->id'";
			}
		elseif ($this->type == "zone_domain") {
			$sql = "SELECT * FROM zone_mx WHERE domain='$this->id' AND zone='$this->second_id'";
			}
		elseif ($this->type == "host") {
			$hostname = $this->object->hostname;
			$ip = $this->object->ip->ip_addr;
			$sql = "SELECT * FROM zone_mx WHERE server='$hostname' OR server='$ip'";
			}
		//we've got the sql setup let's grab the objects
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($m = mysql_fetch_object($db_results)) {
                	$mx = new Mx($m->id);
                        $this->mxs[] = $mx;
			$this->has_children = true;
                        }
		
		//add the number of mxs to the total child objects
		$this->total += count($this->mxs);

	} //check_mxs
	
	function check_cnames() { 
		global $conf, $user;

		//depending upon the type we need to do different selects...
		if ($this->type == "zone") {
			$sql = "SELECT * FROM zone_cname WHERE zone='$this->id'";
			}
		elseif ($this->type == "domain") {
			$sql = "SELECT * FROM zone_cname WHERE domain='$this->id'";
			}
		elseif ($this->type == "zone_domain") {
			$sql = "SELECT * FROM zone_cname WHERE domain='$this->id' AND zone='$this->second_id'";
			}
		elseif ($this->type == "host") {
			$hostname = $this->object->hostname;
			$ip = $this->object->ip->ip_addr;
			$sql = "SELECT * FROM zone_cname WHERE server='$hostname' OR server='$ip'";
			}

		//we've got the sql setup let's grab the objects
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($c = mysql_fetch_object($db_results)) {
			$cname = new Cname($c->id);
			$this->cnames[] = $cname;
			$this->has_children = true;
			}
	
		//add the number of cnames to the total child objects
		$this->total += count($this->cnames);

	} //check_cnames
	
	function check_hosts() { 
		global $user, $conf;
		
		//depending upon the type we need to do different selects...
		if ($this->type == "zone") {
			$sql = "SELECT * FROM host WHERE zone='$this->id'";
			}
		elseif ($this->type == "zone_domain") {
			$sql = "SELECT * FROM host WHERE zone='$this->second_id' AND domain='$this->id'";
			}
		elseif ($this->type == "domain") {
			$sql = "SELECT * FROM host WHERE domain='$this->id'";
			}
		elseif ($this->type == "host") {
			$ha = $this->object->ha;

			//this is only put in here because of zone.physics... they do not specifiy 
			//their hardware addresses for their machines so sql returns everything
			//and the kitchen sink this should be temp... we need physics to fix 
			//this
			if (!$ha or $ha == "000000000000") { $ha = "IAMTHEBOOGIEMAN"; }
				$sql = "SELECT * FROM host WHERE ha='$ha' AND id !='$this->id'";
			} 

		//we've got the sql setup let's grab the objects
		$db_results = mysql_query($sql, $conf['dbh']);
		while ($h = mysql_fetch_object($db_results)) {
			$host = new Host($h->id);
			$this->hosts[] = $host;
			$this->has_children = true;
			}
		
		//add the number of hosts to the total child objects
		$this->total += count($this->hosts);

	} //check_hosts

	/*!
		@function check_pointers
		@discussion looks for child foward pointers this means anything
			    with the same hostname or IP address
	*/
	function check_pointers() {
		global $conf;

		if ($this->type == 'host') {
			$hostname = $this->object->hostname;
			$ip_int = $this->object->ip->ip_int;
			$domain_id = $this->object->domain->id;			
			$sql = "SELECT id FROM pointer WHERE hostname LIKE '$hostname' OR ip='$ip_int'";
			$db_results = mysql_query($sql, $conf['dbh']);
		}
		
		elseif ($this->type == 'zone') {
			$sql = "SELECT id FROM pointer WHERE zone='" . $this->object->id . "'";
		}

		while ($p = mysql_fetch_row($db_results)) {
			$this->pointers[] = new Pointer($p[0]);
			$this->has_children = true;
		}

		$this->total += count($this->pointers);

	} // check_pointer

	//this is a special child function specificly for ranges
	function check_range() {
		global $conf, $user;

		$ip_start = $this->object->start->ip_int;
		$ip_end = $this->object->end->ip_int;
		
		if ($this->object->type == 'dynamic' || $this->object->type == 'ddns') {
			$sql = "SELECT * FROM host WHERE dynamic_range='" . $this->object->id . "'";
		} 
		elseif ($this->object->type == 'static') {
			$sql = "SELECT * FROM host WHERE ( ip<='$ip_end' AND ip>='$ip_start' )";
		}

		$db_results = mysql_query($sql, $conf['dbh']);

		while ($h = mysql_fetch_object($db_results)) {
			$host = new Host($h->id);
			$this->hosts[] = $host;
			$this->has_children = true;				
		}

	$this->total += count($this->hosts); 

	}//check_range

	function check_zones() { 
		global $conf, $user;

		//depending upon the type we need to do different selects...
		if ($this->type == "domain") {
			$sql = "SELECT * FROM zone_domain WHERE domain='$this->id'";
			}
		
		//we've got the sql setup let's grab the objects
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($z = mysql_fetch_object($db_results)) {
			$zone = new Zone($z->zone);
			$this->zones[] = $zone;
			$this->has_children = true;
			}
		
		//add the number of hosts to the total child objects
		$this->total += count($this->zones);


	} //check_zones

	/*!
		@function check_subnet
		@discussion looks for child subnets
	*/
	function check_subnet() {
		global $conf;

		if ($this->type == "ip_block") { 
			$sql = "SELECT id FROM subnet WHERE subnet<=" . $this->object->end ." AND subnet>=" . $this->object->start;
		}
		
		// We have the sql statement
		$db_results = mysql_query($sql, $conf['dbh']);
	
		while ($r = mysql_fetch_object($db_results)) {
			$this->subnets[] = new Subnet($r->id);
			$this->has_children = true;
		}	
		
		$this->total += count($this->subnets);
		

	} // check_subnet


	function show_children() { 
		global $conf, $user;

		require $conf['prefix'] . "/templates/show_children.inc";
	
	} //show_children


} // class Child

?>
