<?php

/*

 $Id: ip.php,v 1.14 2003/07/08 15:24:06 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/class/ip.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header IP Class
	The ip address object ... functions for manipulating, changing
	and checking diffs here.

*/

class IP {

	//This has been removed as of 2.0, here for my sake so I can fix 
	//everything that needs fixing.
	var $id;
	var $ip_int;
	var $ip_addr;
	var $subnet;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function IP ( $ip_int = 0 ) {
		global $conf;

		$this->ip_int	= $ip_int;
		$this->ip_addr	= $this->int2ip($this->ip_int);

		if ($ip_int) {
			$info = $this->get_info();
			$this->subnet	= new Subnet($info->id);
		} 
 
	} // Host

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM subnet WHERE subnet <= '$this->ip_int' ORDER BY subnet DESC LIMIT 1";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

	/*!
		@function get_ip_blocks()
		@discussion gets all the current ipblocks and returns them
	*/
	function get_ip_blocks() {
		global $conf;

		$sql = "SELECT * FROM ip_blocks";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) { 
			$results[] = $r;
		}
		
		return $results;

	} // get_ip_blocks

	/*!
		@function get_block
		@discussion gets a single ip block
	*/
	function get_block($block_id) { 
		global $conf;

		$sql = "SELECT * FROM ip_blocks WHERE id=$block_id";
		$db_results = mysql_query($sql, $conf['dbh']);

		return mysql_fetch_object($db_results);


	} // get_block

	// The PHP functions for this just fail ... and I'm not sure why.
	//   Adam Gretzinger built these functions that work just fine for
	//   our needs.  These can be used generically as well as with the
	//   IP class.
	function int2ip($i) {
		$d[0]=(int)($i/256/256/256);
		$d[1]=(int)(($i-$d[0]*256*256*256)/256/256);
		$d[2]=(int)(($i-$d[0]*256*256*256-$d[1]*256*256)/256);
		$d[3]=$i-$d[0]*256*256*256-$d[1]*256*256-$d[2]*256;
		return "$d[0].$d[1].$d[2].$d[3]";
	} // int2ip

	// Take an IP and turn it into an INT.
	function ip2int($ip) {
		$a=explode(".",$ip);
		return $a[0]*256*256*256+$a[1]*256*256+$a[2]*256+$a[3];
	} // ip2int

	// we might want to use IP objects that aren't in the database
	//   so the current constructor won't work ... if we use this
	//   function to update the current IP we can create an empty
	//   IP (new IP(0)) and then use update_ip_int to set the needed
	//   variables ... the most obvious case for this would be subnet
	//   masks
	function update_ip_int($ip_int) {
		$this->ip_int  = $ip_int;
		$this->ip_addr = $this->int2ip($ip_int);
	}

	// do the same as above but in reverse for a dotted ip
	function update_ip_dotted($ip) {
		$this->ip_addr = $ip;
		$this->ip_int  = $this->ip2int($ip);
	}

	// check to make sure it's in dotted-quad format 
	function is_dotted_quad($ipaddr) {

		if (preg_match("/^\d+\.\d+\.\d+\.\d+$/", $ipaddr) ) {
			return true;
		}		

		return false;

	} //is_dotted_quad

	/*!
		@function update_ip_block_enabled
		@discussion enabled/disabel the ipblock
	*/
	function update_ip_block_enabled($new_status,$block_id) {

		$this->update_block_item('enabled',$new_status,$block_id);

	} // update_ip_block_enabled

	/*!
		@function update_ip_block_start
		@discussion update the start value of an ipblock
	*/
	function update_ip_block_start($new_start,$block_id) {

		$this->update_block_item('start',$new_start,$block_id);

	} // update_ip_block_start

	/*!
		@function update_ip_block_end
		@discussion updates the end value of an ipblock
	*/
	function update_ip_block_end($new_end,$block_id) {

		$this->update_block_item('end',$new_end,$block_id);

	} // update_ip_block_end

	/*!
		@function update_ip_block_name
		@discussion updates the name of the ip block
	*/
	function update_ip_block_name($new_name,$block_id) { 

		$this->update_block_item('name',$new_name,$block_id);

	} // update_ip_block_name

	/*!
		@function update_block_item
		@discussion generic function to update ip blocks
	*/
	function update_block_item($field,$value,$block_id) {
		global $conf, $user;

		// just for safety's sake
		if ($user->is_admin) { 
			$sql = "UPDATE ip_blocks SET $field='$value' WHERE id='$block_id'";
			$db_results = mysql_query($sql, $conf['dbh']);
		} // is admin


	} // update_block_item

	//Check the IP blocks to make sure said IP Int exists
	function ip_exists($ip_int) {
		global $conf;

		$sql = "SELECT * FROM ip_blocks WHERE start<='$ip_int' AND end>='$ip_int' AND enabled='true'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if ($r = mysql_fetch_object($db_results)) {
			return true;
		}

		return false;

	} //ip_exists

	// Check to see if IP Block Exists
	function check_ip_block($start,$end,$name) {
		global $conf;

		// Considers it a duplicate if name the same of if the ips are already in the db
		$sql = "SELECT id FROM ip_blocks WHERE ( start<='$start' AND end>='$end' ) OR name='$name'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		return $results->id;

	} //check_ip_block

	// Add a new IP Block
	function new_block($start,$end,$name,$enabled) {
		global $conf;

		// Insert this new block
		$sql = "INSERT INTO ip_blocks (start,end,name,enabled) VALUES ('$start','$end','$name','$enabled')";
		$db_results = mysql_query($sql, $conf['dbh']);


	} //new_block

	/*!
		@function delete_block	
		@discussion deletes a ip_block, must be full admin
	*/
	function delete_block($block_id) {
		global $conf,$user;

		if ($user->is_admin) { 
			$sql = "DELETE FROM ip_blocks WHERE id='$block_id'";
			$db_results = mysql_query($sql, $conf['dbh']);
		}
		else {
			$conf['ui']->show_access_denied();
		}


	} // delete_block

	// Accessor functions -- things only used by this class or for
	//    debugging purposes

	function _show () {
		print ("IP: ip_int -> $this->ip_int, ip_addr -> $this->ip_addr, ");
		print_r(get_object_vars($this->subnet));
		print ("end IP<br>\n");
	}

	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
}

?>
