<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: workgroup.php,v 1.6 2003/06/30 18:03:41 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/class/workgroup.php,v $

 The workgroup class definition that describes workgroup information
   for given hosts.  Each host has a workgroup definition associated with
   it and it allows us to set per-host DHCP options as well as dynamic
   VLAN settings.

*/

class Workgroup {
	var $id;

	var $name;
	var $original_name;

	// these are Subnet & VLAN objects
	var $subnet;
	var $vlan;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Workgroup( $workgroup_id ) {
		global $conf;

		$this->id = $workgroup_id;
		$info = $this->get_info();

		if ( ! $info ) {
			return false;
		}

		$this->name		= $info->name;
		$this->original_name	= $info->original_name;
		$this->subnet		= new Subnet($info->subnet);
		$this->vlan		= new VLAN($info->vlan);
	} // Workgroup

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM workgroup WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

        /*!
                @function get_options
                @discussion get the local options for this object assumes $this
        */
        function get_options() {
                global $conf;

                $sql = "SELECT * FROM workgroup_option_local WHERE workgroup=$this->id";
                $db_result = mysql_query($sql, $conf['dbh']);

                while ( $obj = mysql_fetch_object($db_result) ) {
                        $options[] = new Option($obj->id, "subnet");
                }

                return $options;

        } // get_options


	// the update functions... there are a bunch of them
        function update_name ($new_name) {
                $this->update_item('name', $new_name);
                $this->name = $new_name;
        } // update_name

	function update_original_name ($new_name) {
                $this->update_item('original_name', $new_name);
                $this->original_name = $new_name;
        } // update_original_name

	function update_subnet ($subnet) {
                $this->update_item('subnet', $subnet);
                $this->subnet = $subnet;
        } // update_subnet

	function update_vlan($vlan) {
                $this->update_item('vlan', $vlan);
                $this->vlan = $vlan;
        } // update_vlan

        function update_item($type, $new_item) {
                global $conf;

                $sql = "UPDATE workgroup SET $type='$new_item' WHERE id='$this->id'";
                $db_results = mysql_query($sql, $conf['dbh']);
        } // update_item

	// get the ranges that this workgroup is allowed to be used in
	function get_ranges() {
                global $conf;

                $sql = "SELECT id FROM ranges WHERE subnet=". $this->subnet->id;
                $db_result = mysql_query($sql, $conf['dbh']);

		$ranges = array();

		while ($range = mysql_fetch_object($db_result) ) {
			$ranges[] = new Range($range->id);	
		}

		return $ranges;
        } // get_ranges
}

?>
